/**
 * @semantic-ui/query v0.10.8
 * DOM querying and manipulation library for Semantic UI
 *
 * @license ISC
 * @copyright (c) 2025 Jack Lukic <jack@semantic-ui.com>
 * @homepage https://next.semantic-ui.com
 *
 * This source code is licensed under the ISC license found in the
 * LICENSE file in the root directory of this source tree.
 */
import{isClient as I}from"@semantic-ui/utils";import{camelToKebab as B,each as T,findIndex as D,inArray as b,isArray as M,isClient as k,isDOM as x,isFunction as L,isObject as q,isPlainObject as j,isString as v}from"@semantic-ui/utils";var y=class h{static globalThisProxy=new Proxy({},{get(e,t){return globalThis[t]},set(e,t,n){return globalThis[t]=n,!0}});static eventHandlers=[];constructor(e,{root:t=document,pierceShadow:n=!1,prevObject:i=null}={}){let s=[];if(t){if(e instanceof h&&(s=e),e===window||e===globalThis||b(e,["window","globalThis"])||e==h.globalThisProxy)s=[h.globalThisProxy],this.isBrowser=k,this.isGlobal=!0;else if(M(e)||e instanceof NodeList||e instanceof HTMLCollection)e=Array.from(e),s=e;else if(v(e))if(e.trim().slice(0,1)=="<"){let r=document.createElement("template");r.innerHTML=e.trim(),s=Array.from(r.content.childNodes)}else s=n?this.querySelectorAllDeep(t,e):t.querySelectorAll(e);else x(e)?s=[e]:e instanceof NodeList&&(s=e);this.selector=e,this.length=s.length,this.options={root:t,pierceShadow:n},this.prevObject=i,Object.assign(this,s)}}chain(e){return this.isGlobal&&!e?new h(globalThis,this.options):new h(e,{...this.options,prevObject:this})}end(){return this.prevObject||this}querySelectorAllDeep(e,t,n=!0){let i=new Set,s=x(t),r=!1,o=!1;n&&(s&&e==t||!s&&e.matches&&e.matches(t))&&i.add(e),s?o=!0:e.querySelectorAll&&(e.querySelectorAll(t).forEach(l=>i.add(l)),o=!0);let w=(l,a)=>{let c=a.split(" "),u,f;return T(c,(p,A)=>{if(u=c.slice(0,A+1).join(" "),l.matches(u)){f=c.slice(A+1).join(" ");return}}),f||a},m=(l,a)=>{s&&(l===a||l.contains)?l.contains(a)&&(i.add(a),r=!0):l.querySelectorAll&&l.querySelectorAll(a).forEach(c=>i.add(c))},d=(l,a,c)=>{if(!(s&&r)){if(c===!0&&(m(l,a),o=!0),l.nodeType===Node.ELEMENT_NODE&&l.shadowRoot){let u=w(l,a);m(l.shadowRoot,u),d(l.shadowRoot,u,!o)}if(l.assignedNodes){let u=w(l,a),f=l.assignedNodes();for(let p=0;p<f.length;p++)d(f[p],u,o)}if(l.childNodes&&l.childNodes.length){let u=l.childNodes.length;for(let f=0;f<u;f++)d(l.childNodes[f],a,o)}}};return d(e,t),Array.from(i)}each(e){for(let t=0;t<this.length;t++){let n=this[t],i=this.chain(n);e.call(i,n,t)}return this}removeAllEvents(){h.eventHandlers=[]}find(e){let t=Array.from(this).flatMap(n=>this.options.pierceShadow?this.querySelectorAllDeep(n,e,!1):Array.from(n.querySelectorAll(e)));return this.chain(t)}parent(e){let t=Array.from(this).map(n=>n.parentElement).filter(Boolean);return e?this.chain(t).filter(e):this.chain(t)}children(e){let t=Array.from(this).flatMap(i=>Array.from(i.children)),n=e?t.filter(i=>i.matches(e)):t;return this.chain(n)}siblings(e){let t=Array.from(this).flatMap(n=>{if(n.parentNode)return Array.from(n.parentNode.children).filter(i=>i!==n)}).filter(Boolean);return e?this.chain(t).filter(e):this.chain(t)}index(e){let t=this.el();if(!t?.parentNode)return-1;let i=this.chain(t.parentNode.children).filter(e).get(),s=this.get();return D(i,r=>b(r,s))}indexOf(e){let t=this.get(),n=this.filter(e).get(0);return t.indexOf(n)}filter(e){if(!e)return this;let t=[];return L(e)?t=Array.from(this).filter(e):t=Array.from(this).filter(n=>{if(v(e))return n.matches&&n.matches(e);if(e instanceof h)return e.get().includes(n);{let i=M(e)?e:[e];return b(n,i)}}),this.chain(t)}is(e){return Array.from(this).filter(n=>typeof e=="string"?n.matches&&n.matches(e):this.isGlobal?b(e,["window","globalThis"]):(e instanceof h?e.get():[e]).includes(n)).length===this.length}not(e){let t=Array.from(this).filter(n=>typeof e=="string"?!n.matches||n.matches&&!n.matches(e):this.isGlobal?!b(e,["window","globalThis"]):!(e instanceof h?e.get():[e]).includes(n));return this.chain(t)}closest(e){let t=Array.from(this).map(n=>{if(this.options.pierceShadow)return this.closestDeep(n,e);if(e&&n?.closest)return n.closest(e);if(this.isGlobal)return b(e,["window","globalThis"])}).filter(Boolean);return this.chain(t)}closestDeep(e,t){let n=e,i=x(t),s=v(t);for(;n;){if(i&&n===t||s&&n.matches(t))return n;if(n.parentElement)n=n.parentElement;else if(n.parentNode&&n.parentNode.host)n=n.parentNode.host;else return}}ready(e){return this.is(document)&&document.readyState=="loading"?this.on("ready",e):e.call(document,new Event("DOMContentLoaded")),this}getEventAlias(e){return{ready:"DOMContentLoaded"}[e]||e}getEventArray(e){return e.split(" ").map(t=>this.getEventAlias(t)).filter(Boolean)}on(e,t,n,i){let s=[],r,o;return q(n)?(i=n,r=t):v(t)?(o=t,r=n):L(t)&&(r=t),this.getEventArray(e).forEach(m=>{let d=i?.abortController||new AbortController,l=i?.eventSettings||{},a=d.signal;this.each(c=>{let u;o&&(u=g=>{let N;if(g.composed&&g.composedPath){let C=g.composedPath(),H=D(C,E=>E==c);C=C.slice(0,H),N=C.find(E=>E instanceof Element&&E.matches&&E.matches(o))}else N=g.target.closest(o);N&&r.call(N,g)});let f=u||r,p=c==h.globalThisProxy?globalThis:c;p.addEventListener&&p.addEventListener(m,f,{signal:a,...l});let A={el:c,eventName:m,eventListener:f,abortController:d,delegated:o!==void 0,handler:r,abort:g=>d.abort(g)};s.push(A)})}),h.eventHandlers||(h.eventHandlers=[]),h.eventHandlers.push(...s),i?.returnHandler?s.length==1?s[0]:s:this}one(e,t,n,i){let s,r;q(n)?(i=n,s=t):v(t)?(r=t,s=n):L(t)&&(s=t),i=i||{};let o=new AbortController;i.abortController=o;let w=function(...m){o.abort(),s.apply(this,m)};return r?this.on(e,r,w,i):this.on(e,w,i)}off(e,t){let n=this.getEventArray(e);return h.eventHandlers=h.eventHandlers.filter(i=>{if((!e||b(i.eventName,n))&&(!t||t?.eventListener==i.eventListener||i.eventListener===t||i.handler===t)){let s=this.isGlobal?globalThis:i.el;return s.removeEventListener&&s.removeEventListener(i.eventName,i.eventListener),!1}return!0}),this}trigger(e,t){return this.each(n=>{if(typeof n.dispatchEvent!="function")return;let i=new Event(e,{bubbles:!0,cancelable:!0});t&&Object.assign(i,t),n.dispatchEvent(i)})}click(e){return this.trigger("click",e)}dispatchEvent(e,t={},n={}){let i={bubbles:!0,cancelable:!0,composed:!0,detail:t,...n};return this.each(s=>{let r=new CustomEvent(e,i);s.dispatchEvent(r)}),this}remove(){return this.each(e=>e.remove())}addClass(e){let t=e.split(" ");return this.each(n=>n.classList.add(...t))}hasClass(e){return Array.from(this).some(t=>t.classList.contains(e))}removeClass(e){let t=e.split(" ");return this.each(n=>n.classList.remove(...t))}toggleClass(e){let t=e.split(" ");return this.each(n=>n.classList.toggle(...t))}html(e){if(e!==void 0)return this.each(t=>t.innerHTML=e);if(this.length>0)return this.map(t=>t.innerHTML||t.nodeValue).join("")}outerHTML(e){if(e!==void 0)return this.each(t=>t.outerHTML=e);if(this.length)return this.map(t=>t.outerHTML).join("")}getSlot(e){return this.map(t=>{if(t.tagName.toLowerCase()=="slot"&&(!e||t.name==e)){let n=t.assignedNodes({flatten:!0});if(n)return this.chain(n).html()}else if(t.shadowRoot){let n=e?`slot[name="${e}"]`:"slot:not([name])",s=t.shadowRoot.querySelector(n).assignedNodes({flatten:!0});if(s)return this.chain(s).html()}else{let n=e?`[slot="${e}"]`:":not([slot])";return this.chain(t).find(n).html()}}).join("")}setSlot(e,t){let n;return t?n=e:t=e,this.each(i=>{i.tagName.toLowerCase()=="slot"&&(i=i.getRootNode().getRootNode()?.host);let s=this.chain(i);if(n){let r=`[slot="${n}"]`,o=this.chain(i).find(r);o.exists()||(s.append(`<span slot="${n}"></span>`),o=this.chain(i).find(r)),o.html(t)}else s.html(t)})}text(e){if(e!==void 0)return this.each(t=>t.textContent=e);{let t=i=>i.nodeName==="SLOT"?i.assignedNodes({flatten:!0}):i.childNodes,n=this.map(i=>this.getTextContentRecursive(t(i)));return n.length>1?n:n[0]}}getTextContentRecursive(e){return Array.from(e).map(t=>{if(t.nodeType===Node.TEXT_NODE)return t.nodeValue;if(t.nodeName==="SLOT"){let n=t.assignedNodes({flatten:!0});return this.getTextContentRecursive(n)}else return this.getTextContentRecursive(t.childNodes)}).join("").trim()}textNode(){return Array.from(this).map(e=>Array.from(e.childNodes).filter(t=>t.nodeType===Node.TEXT_NODE).map(t=>t.nodeValue).join("")).join("")}map(...e){return Array.from(this).map(...e)}value(e){if(e!==void 0)return this.each(t=>{(t instanceof HTMLInputElement||t instanceof HTMLSelectElement||t instanceof HTMLTextAreaElement)&&(t.value=e)});{let t=this.map(n=>{if(n instanceof HTMLInputElement||n instanceof HTMLSelectElement||n instanceof HTMLTextAreaElement)return n.value});return t.length>1?t:t[0]}}val(...e){return this.value(...e)}focus(){return this.length&&this[0].focus(),this}blur(){return this.length&&this[0].blur(),this}css(e,t=null,n={includeComputed:!1}){let i=Array.from(this);if(j(e)||t!==null)return j(e)?Object.entries(e).forEach(([s,r])=>{i.forEach(o=>o.style.setProperty(B(s),r))}):i.forEach(s=>s.style.setProperty(B(e),t)),this;if(i?.length){let s=i.map(r=>{let o=r.style[e];if(n.includeComputed)return window.getComputedStyle(r).getPropertyValue(e);if(o)return o});return i.length===1?s[0]:s}}computedStyle(e){return this.css(e,null,{includeComputed:!0})}cssVar(e,t){return this.css(`--${e}`,t,{includeComputed:!0})}attr(e,t){if(j(e))Object.entries(e).forEach(([n,i])=>{this.each(s=>s.setAttribute(n,i))});else if(t!==void 0)this.each(n=>n.setAttribute(e,t));else if(this.length){let n=this.map(i=>i.getAttribute(e));return n.length>1?n:n[0]}}removeAttr(e){return this.each(t=>t.removeAttribute(e))}el(){return this.get(0)}get(e){return e!==void 0?this[e]:Array.from(this)}eq(e){return this.chain(this[e])}first(){return this.eq(0)}last(){return this.eq(this.length-1)}prop(e,t){return t!==void 0?this.each(n=>{n[e]=t}):this.length==0?void 0:this.length===1?this[0][e]:this.map(n=>n[e])}next(e){let t=this.map(n=>{let i=n.nextElementSibling;for(;i;){if(!e||i.matches(e))return i;i=i.nextElementSibling}return null}).filter(Boolean);return this.chain(t)}prev(e){let t=this.map(n=>{let i=n.previousElementSibling;for(;i;){if(!e||i.matches(e))return i;i=i.previousElementSibling}return null}).filter(Boolean);return this.chain(t)}height(e){return this.prop("innerHeight",e)||this.prop("clientHeight",e)}width(e){return this.prop("innerWidth",e)||this.prop("clientWidth",e)}scrollHeight(e){return(this.isGlobal&&this.isBrowser?this.chain(document.documentElement):this).prop("scrollHeight",e)}scrollWidth(e){return(this.isGlobal&&this.isBrowser?this.chain(document.documentElement):this).prop("scrollWidth",e)}scrollLeft(e){return(this.isGlobal&&this.isBrowser?this.chain(document.documentElement):this).prop("scrollLeft",e)}scrollTop(e){return(this.isGlobal&&this.isBrowser?this.chain(document.documentElement):this).prop("scrollTop",e)}clone(){let e=document.createDocumentFragment();return this.each(t=>{e.appendChild(t.cloneNode(!0))}),this.chain(e.childNodes)}reverse(){let e=this.get().reverse();return this.chain(e)}insertContent(e,t,n){this.chain(t).each(s=>{if(e.insertAdjacentElement)e.insertAdjacentElement(n,s);else switch(n){case"beforebegin":e.parentNode?.insertBefore(s,e);break;case"afterbegin":e.insertBefore(s,e.firstChild);break;case"beforeend":e.appendChild(s);break;case"afterend":e.parentNode?.insertBefore(s,e.nextSibling);break}})}prepend(...e){return this.each(t=>{T(e,n=>{this.insertContent(t,n,"afterbegin")})})}append(...e){return this.each(t=>{T(e,n=>{this.insertContent(t,n,"beforeend")})})}insertBefore(e){return this.chain(e).each(t=>{this.insertContent(t,this.selector,"beforebegin")})}insertAfter(e){return this.chain(e).each(t=>{this.insertContent(t,this.selector,"afterend")})}detach(){return this.each(e=>{e.parentNode&&e.parentNode.removeChild(e)})}naturalWidth(){let e=this.map(t=>{let n=$(t).clone();n.insertAfter(t).css({position:"absolute",display:"block",transform:"translate(-9999px, -9999px)",zIndex:"-1"});let i=n.width();return n.remove(),i});return e.length>1?e:e[0]}naturalHeight(){let e=this.map(t=>{let n=$(t).clone();n.insertAfter(t).css({position:"absolute",display:"block",transform:"translate(-9999px, -9999px)",zIndex:"-1"});let i=n.height();return n.remove(),i});return e.length>1?e:e[0]}offsetParent({calculate:e=!0}={}){return Array.from(this).map(t=>{if(!e)return t.offsetParent;let n,i,s,r,o=t?.parentNode;for(;o&&!i&&!s&&!r;)o=o?.parentNode,o&&(n=$(o),i=n.computedStyle("position")!=="static",s=n.computedStyle("transform")!=="none",r=n.is("body"));return o})}count(){return this.length}exists(){return this.length>0}initialize(e){document.addEventListener("DOMContentLoaded",()=>{this.settings(e)})}settings(e){this.each(t=>{T(e,(n,i)=>{t[i]=n})})}setting(e,t){this.each(n=>{n[e]=t})}component(){let e=this.map(t=>t.component).filter(Boolean);return e.length>1?e:e[0]}dataContext(){let e=this.map(t=>t.dataContext).filter(Boolean);return e.length>1?e:e[0]}};var S=function(h,e={}){let t=typeof window<"u";return!e?.root&&t&&(e.root=document),new y(h,e)},R=function(h,e={}){return e.pierceShadow=!0,S(h,e)},P,G,z=function({dollar:h=!0,doubleDollar:e=!0,query:t=!0}={}){I&&(h&&(P=window.$,window.$=S),e&&(G=window.$$,window.$$=R),t&&(window.Query=y))},F=function(h){return window.$===S&&(window.$=P),window.$$===R&&(window.$$=G),typeof h=="object"&&h.removeQuery&&window.Query===y&&(window.Query=void 0),S},X=function(){return new y(...arguments)};export{S as $,R as $$,y as Query,z as exportGlobals,F as restoreGlobals,X as useAlias};
//# sourceMappingURL=index.min.js.map
